-- let's wait for some gossip
local PAMPHLET = "I'll take a pamphlet."

local calledset = false;

-- 68.1 17.1 Pandaren Embassy (No Doomsayer)
-- 78.6 37.3 Keep Steps
-- 68.6 42.7 Dwarven District Town
-- 72.7 47.8 North Old Town
-- 67.6 58.0 West Old Town
-- 77.0 63.6 PvP Area Old Town
-- 66.5 76.5 Doomsayer
-- 61.3 75.0 West of AH
-- 55.6 68.5 Fishing Quest
-- 59.0 53.0 East Cathedral
-- 53.9 52.9 Cathedral Steps
-- 47.4 49.6 Catehdral Fountain
-- 51.2 70.6 Stockades
-- 44.0 81.2 Illidari Camp
-- 50.2 86.7 Mage Tower
-- 62.2 32.7 Doomsayer
-- 66.2 71,3 Trade Distrct FP

-- 33.85 67.93 Spirits
-- 40.16 63.88 Barber
-- 40.66 46.85 Wisdom
-- 39.88 77.98 Gob Slums
-- 44.20 69.00 Strength Elevator
-- 48.75 57.09 Flightmaster
-- 48.22 48.69 Graveyard
-- 52.66 63.93 Drag Elevator
-- 52.16 74.96 AH
-- 51.83 85.04 Front Gate
-- 56.81 50.34 Central Drag
-- 59.13 60.95 Xmog
-- 67.93 46.71 Honor
-- 69.17 32.86 Brawlers Guild

local doomsayers = {
    -- Stormwind
    ["Steps"] = { 78.6, 37.3 },
    ["Keep Bridge"] = { 68.6, 42.7 },
    ["Keep Gate"] = { 72.7, 47.8 },
    ["Canals"] = { 67.6, 58.0 },
    ["PvP Area"] = { 77.0, 63.6 },
    ["Inn by AH"] = { 61.3, 75.0 },
    ["Fishing Quest"] = { 55.6, 68.5 },
    ["Vin"] = { 59.0, 53.0 },
    ["Steps"] = { 53.9, 52.9  },
    ["Fountain"] = { 47.4, 49.6 },
    ["Stockades"] = { 51.2, 70.6 },
    ["Illidari Camp"] = { 44.0, 81.2 },
    ["Mage Tower"] = { 50.2, 86.7 },
    ["Flight Point"] = { 66.2, 71,3 },
    ["Stormwind Gate"] = { 66.6, 76.5 },
    ["Auction House"] = { 62.2, 32.7 },

    -- Ogrimmar
    ["Spirits"] = { 33.85, 67.93 },
    ["Barber"] = { 40.16, 63.88 },
    ["Wisdom"] = { 40.66, 46.85 },
    ["Gob Slums"] = { 39.88, 77.98 },
    ["Strength Elevator"] = { 44.20, 69.00 },
    ["Flightmaster"] = { 48.75, 57.09 },
    ["Graveyard"] = { 48.22, 48.69 },
    ["Drag Elevator"] = { 52.66, 63.93 },
    ["AH"] = { 52.16, 74.96 },
    ["Front Gate"] = { 51.83, 85.04 },
    ["Central Drag"] = { 56.81, 50.34 },
    ["Xmog"] = { 59.13, 60.95 },
    ["Honor"] = { 67.93, 46.71 },
    ["Brawlers Guild"] = { 69.17, 32.86 },
}

-- With this check distance, we can tell the difference between
-- the Graveyard in Ogrimmar and the Cathedral Fountain
local CHECKDIST = 0.75

function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

local function FindCurrentLocation()
    if (not calledset) then
        calledset = true
        SetMapToCurrentZone()
    end

    local posX, posY = GetPlayerMapPosition("player")
    posX = posX * 100
    posY = posY * 100

    for name, loc in pairs(doomsayers) do
        local xmin, xmax = loc[1] - CHECKDIST, loc[1] + CHECKDIST
        local ymin, ymax = loc[2] - CHECKDIST, loc[2] + CHECKDIST

        -- print (name, loc[1], loc[2])
        if (posX > xmin and posX < xmax and posY > ymin and posY < ymax) then
            return name
        end
    end
    return "Unknown"
end

local function GOSSIP_SHOW()
	local npcName, realm = UnitName("npc");
    if (npcName == "Doomsayer") then

        -- Sense Demons, Detect Demon, Spectral Sight
        local buff = UnitBuff("player", GetSpellInfo(47524)) or UnitBuff("player", GetSpellInfo(11407)) or UnitBuff("player", GetSpellInfo(188501))
        if (buff ~= nil) then		
            local text1, g1, text2, g2 = GetGossipOptions()

            if (text2 or (text1 and text1 ~= PAMPHLET)) then
                local location = FindCurrentLocation()
                local posX, posY = GetPlayerMapPosition("player")
                print ("ZOMG! It's a demon!")
                local message = "Dread Infiltrator found at "..location.." ("..round(posX*100, 2)..", "..round(posY*100, 2)..") in "..GetSubZoneText()

                if (IsInRaid()) then
                    SendChatMessage(message, "RAID")
                    SendChatMessage(message, "RAID_WARNING")
                elseif (IsInGroup()) then
                    SendChatMessage(message, "PARTY")
                else
                    SendChatMessage(message, "CHANNEL", "COMMON", 1)
                end
            elseif (not text1 or text1 == PAMPHLET) then
                local location = FindCurrentLocation()
                local message = location.." ("..GetSubZoneText()..") clear."
                if (IsInRaid()) then
                    SendChatMessage(message, "RAID")
                elseif (IsInGroup()) then
                    SendChatMessage(message, "PARTY")
                end
            end
        else
            SendChatMessage("attempts to find a Doomsayer without being able to see them.", "EMOTE")
        end
    end
end

local frame = CreateFrame("Frame");
frame:Show();
frame:SetScript("OnEvent", GOSSIP_SHOW);
frame:RegisterEvent("GOSSIP_SHOW");
